<template>
  <div class="col-md-10 pt-4">
    <div class="table-responsive">
      <my-vuetable :apiUrl="apiUrl" :fields="fields" :tableName="tableName" :perPage="perPage">
        <template slot="header-slot">
          <div class="col-6 col-md-2">
            <app-content-create-modal></app-content-create-modal>
          </div>
        </template>
        <template slot="actions-slot" slot-scope="props">
          <div class="d-flex">
            <app-content-edit-modal @show="selectData(props.rowData)" :content="selectedAppContent"></app-content-edit-modal>
            <delete-modal
              :data="{titleData: (selectedAppContent) ?selectedAppContent.title:''}"
              @deleteHandler="deleteHandler()"
              @show="selectData(props.rowData)"
            ></delete-modal>
          </div>
        </template>
      </my-vuetable>
    </div>
  </div>
</template>

<script>
import MyVuetable from "@/components/table/MyVuetable";
import FieldDefs from "./FieldDefs";
import EventBus from "@/EventBus.js";
import AppContentCreateModal from "./modals/AppContentCreateModal";
import AppContentEditModal from "./modals/AppContentEditModal";
import DeleteModal from "@/components/general/modals/DeleteModal";

export default {
  data() {
    return {
      fields: FieldDefs,
      tableName: "AppContents",
      selectedAppContent: {},
      selectedCategory: "show-all",
      perPage: 5
    };
  },
  computed: {
    apiUrl() {
      return (
        this.baseUrl + `/api/${this.$store.getters.appId.hashed}/app-content`
      );
    }
  },
  components: {
    MyVuetable,
    AppContentCreateModal,
    AppContentEditModal,
    DeleteModal
  },
  methods: {
    selectData(data) {
      this.selectedAppContent = {
        id: data.id,
        title: data.title,
        category: data.category,
        image_url: data.image_url,
        description: data.content.description,
        buttonLabel: data.content.buttonLabel,
        buttonType: data.content.buttonType,
        data: data.content.data,
        status: data.is_active
      };
    },
    async deleteHandler() {
      try {
        let response = await this.$axios.delete(
          process.env.MIX_APP_URL +
            `/api/${this.$store.getters.appId.hashed}/app-content/${
              this.selectedAppContent.id
            }`
        );
        this.$notify({
          group: "notif",
          type: "info",
          title: "Info",
          text: response.data.message
        });
        EventBus.$emit("hideModal");
        EventBus.$emit("refreshTable");
      } catch (error) {
        this.$notify({
          group: "error",
          type: "error",
          title: "Error",
          text: error.response.data.message
        });
      }
    }
  }
};
</script>
<style lang="scss" scoped>
.dropdown-toggle::after {
  display: none;
}
select::-ms-expand {
  display: none !important;
}
select {
  border: none;
  -webkit-appearance: none !important;
  appearance: none !important;
}
</style>
